<div *ngIf="run$ | async as run" class="dark">
  <mat-toolbar>
    Started: {{run.dateStart | date:'full'}} | Ended: {{run.dateEnd | date:'full'}} | Duration: {{run.duration | duration}} | System: {{run.location.starSystem}}
    <ng-template [ngIf]="run.location.body"> | Body: {{run.location.body}}</ng-template>
  </mat-toolbar>

  <div class="card-flex">
    <mat-card class="card-stats">
      <mat-card-header>
        <mat-card-title>Stats</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <ul>
          <li>Analyzed journal entries: {{run.eventCount}}</li>
          <li *ngIf="run.loadGameCount > 0">Game starts: {{run.loadGameCount}}</li>
          <li *ngIf="run.prospectedAsteroidCount > 0">Prospected asteroids: {{run.prospectedAsteroidCount}} (Hit rate {{(run.prospectedAsteroidCount / run.launchedProspectors) | percent:'2.1'}})</li>
          <li *ngIf="run.prospectedAsteroidDuplicateCount > 0">Prospected same asteroids multiple times: {{run.prospectedAsteroidDuplicateCount}}</li>
          <li *ngIf="run.launchedProspectors > 0">Launched prospector drones: {{run.launchedProspectors}}</li>
          <li *ngIf="run.launchedCollections > 0">Launched collection drones: {{run.launchedCollections}}</li>
          <li>Total launched drones: {{run.launchedCollections + run.launchedProspectors}}</li>
          <li *ngFor="let item of objectKeys(run.refinedMining)">Refined {{item}}: {{run.refinedMining[item]}}</li>
          <li *ngFor="let item of objectKeys(run.ejectCargoCount)">Ejected {{item}}: {{run.ejectCargoCount[item]}}</li>
          <li *ngFor="let item of objectKeys(run.materialCollectedCount)">Collected {{item}}: {{run.materialCollectedCount[item]}}</li>
        </ul>
        <hr>
        <b>By Hour</b><br>
        <ul>
          <li *ngIf="run.launchedProspectors > 0">Launched prospector drones: {{(run.launchedProspectors / (run.duration / 1000 / 60 / 60)) | number}}</li>
          <li *ngIf="run.launchedCollections > 0">Launched collection drones: {{(run.launchedCollections / (run.duration / 1000 / 60 / 60)) | number}}</li>
          <li>Total launched drones: {{((run.launchedProspectors +  run.launchedCollections) / (run.duration / 1000 / 60 / 60)) | number}}</li>
          <li *ngFor="let item of objectKeys(run.refinedMining)">Refined {{item}}: {{(run.refinedMining[item] / (run.duration / 1000 / 60 / 60)) | number}}</li>
          <li *ngFor="let item of objectKeys(run.ejectCargoCount)">Ejected {{item}}: {{(run.ejectCargoCount[item] / (run.duration / 1000 / 60 / 60)) | number}}</li>
          <li *ngFor="let item of objectKeys(run.materialCollectedCount)">Collected {{item}}: {{(run.materialCollectedCount[item] / (run.duration / 1000 / 60 / 60)) | number}}</li>
        </ul>
        <hr>
        <b>By Minute</b><br>
        <ul>
          <li *ngIf="run.launchedProspectors > 0">Launched prospector drones: {{(run.launchedProspectors / (run.duration / 1000 / 60)) | number}}</li>
          <li *ngIf="run.launchedCollections > 0">Launched collection drones: {{(run.launchedCollections / (run.duration / 1000 / 60)) | number}}</li>
          <li>Total launched drones: {{((run.launchedProspectors +  run.launchedCollections) / (run.duration / 1000 / 60)) | number}}</li>
          <li *ngFor="let item of objectKeys(run.refinedMining)">Refined {{item}}: {{(run.refinedMining[item] / (run.duration / 1000 / 60)) | number}}</li>
          <li *ngFor="let item of objectKeys(run.ejectCargoCount)">Ejected {{item}}: {{(run.ejectCargoCount[item] / (run.duration / 1000 / 60)) | number}}</li>
          <li *ngFor="let item of objectKeys(run.materialCollectedCount)">Collected {{item}}: {{(run.materialCollectedCount[item] / (run.duration / 1000 / 60)) | number}}</li>
        </ul>
      </mat-card-content>
    </mat-card>

    <mat-card class="card-timeline">
      <mat-card-header>
        <mat-card-title>Timeline</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <ngx-charts-line-chart
          [results]="cargoChartData"
          [yAxis]="true"
          [xAxis]="true"
          [showXAxisLabel]="true"
          [legend]="true"
          [timeline]="true"
          scheme="picnic"
          xAxisLabel="Time"
        ></ngx-charts-line-chart>
      </mat-card-content>
    </mat-card>

    <mat-card class="card-asteroid-material-stats">
      <mat-card-header>
        <mat-card-title>Material stats</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <table mat-table [dataSource]="asteroidMaterialStats">
          <ng-container matColumnDef="material">
            <th mat-header-cell *matHeaderCellDef>Material</th>
            <td mat-cell *matCellDef="let element">{{element.material}}</td>
          </ng-container>
          <ng-container matColumnDef="amount">
            <th mat-header-cell *matHeaderCellDef>Amount</th>
            <td mat-cell *matCellDef="let element">{{element.amount}}</td>
          </ng-container>
          <ng-container matColumnDef="highest">
            <th mat-header-cell *matHeaderCellDef> Highest </th>
            <td mat-cell *matCellDef="let element">{{element.highest | percent:'1.2'}}</td>
          </ng-container>
          <ng-container matColumnDef="average">
            <th mat-header-cell *matHeaderCellDef>Average</th>
            <td mat-cell *matCellDef="let element">{{element.average | percent:'1.2'}}</td>
          </ng-container>
          <tr mat-header-row *matHeaderRowDef="asteroidMaterialStatsColumns"></tr>
          <tr mat-row *matRowDef="let row; columns: asteroidMaterialStatsColumns;"></tr>
        </table>
      </mat-card-content>
    </mat-card>

    <mat-card class="card-materialpercentiles">
      <mat-card-header>
        <mat-card-title>Material percent amount</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <ngx-charts-bubble-chart
          [results]="asteroidMaterialPercentilesCharData"
          scheme="picnic"
        >
          <ng-template #tooltipTemplate let-model="model">
            <h3>{{model.y}} {{model.x}}%</h3>
            <h2>Amount {{model.r}}</h2>
          </ng-template>
        </ngx-charts-bubble-chart>
      </mat-card-content>
    </mat-card>

    <mat-card class="card-foundmaterials">
      <mat-card-header>
        <mat-card-title>Amount of found materials</mat-card-title>
      </mat-card-header>
      <mat-card-content>
        <ngx-charts-pie-chart
          [results]="asteroidMaterialCountChartData"
          [labels]="true"
          scheme="picnic"
        ></ngx-charts-pie-chart>
      </mat-card-content>
    </mat-card>
  </div>

  <hr>
  <div class="header-cumulative-frequency">
    <h2>%Content Distribution</h2>
  </div>
  <div>
    <mat-form-field appearance="fill">
      <mat-label>Chart type</mat-label>
      <mat-select [(value)]="cumulativeFrequencyChartType">
        <mat-option value="CDFb">CDFb</mat-option>
        <mat-option value="CDF">CDF</mat-option>
      </mat-select>
    </mat-form-field>
  </div>

  <div class="card-flex">
    <ng-template ngFor let-item [ngForOf]="objectKeys(asteroidMaterialCumulativeFrequencyChartDataCDFb).sort()">
      <mat-card class="card-cumulative-frequency" *ngIf="cumulativeFrequencyChartType === 'CDFb'">
        <mat-card-header>
          <mat-card-title>CDFb: {{item}}</mat-card-title>
        </mat-card-header>
        <mat-card-content>
          <ngx-charts-line-chart
            [results]="asteroidMaterialCumulativeFrequencyChartDataCDFb[item]"
            [yAxis]="true"
            [showXAxisLabel]="true"
            xAxisLabel="%content"
            [xAxis]="true"
            [showYAxisLabel]="true"
            yAxisLabel="% of asteroids above %content (CDFb)"
            [yAxisTickFormatting]="percentTickFormatting"
            [yScaleMin]="0"
            [yScaleMax]="1"
            [xScaleMin]="0"
            [xScaleMax]="70"
            [legend]="asteroidMaterialCumulativeFrequencyChartDataCDFb[item].length > 1"
            scheme="picnic"
          >
          </ngx-charts-line-chart>
        </mat-card-content>
      </mat-card>
      <mat-card class="card-cumulative-frequency" *ngIf="cumulativeFrequencyChartType === 'CDF'">
        <mat-card-header>
          <mat-card-title>CDF: {{item}}</mat-card-title>
        </mat-card-header>
        <mat-card-content>
          <ngx-charts-line-chart
            [results]="asteroidMaterialCumulativeFrequencyChartDataCDF[item]"
            [yAxis]="true"
            [showXAxisLabel]="true"
            xAxisLabel="%content"
            [xAxis]="true"
            [showYAxisLabel]="true"
            yAxisLabel="% of asteroids below %content (CDF)"
            [yAxisTickFormatting]="percentTickFormatting"
            [yScaleMin]="0"
            [yScaleMax]="1"
            [xScaleMin]="0"
            [xScaleMax]="70"
            [legend]="asteroidMaterialCumulativeFrequencyChartDataCDF[item].length > 1"
            scheme="picnic"
          >
          </ngx-charts-line-chart>
        </mat-card-content>
      </mat-card>
    </ng-template>
  </div>
</div>
